
package de.codedo.conflicteditor.gui;

import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JPanel;

public class ButtonPanel extends JPanel
{
    private JButton _currentValueButton;
    private JButton _conflictValueButton;
    private JButton _previewButton;
    private JButton _saveButton;

    public ButtonPanel()
    {
        super();
        setLayout(new FlowLayout());
        createButtons();
    }

    private void createButtons()
    {
        createCurrentValueButton();
        createConflictValueButton();
        createPreviewButton();
        createSaveButton();
    }

    private void createCurrentValueButton()
    {
        _currentValueButton = new JButton("use current value");
        _currentValueButton.setEnabled(false);
        add(_currentValueButton);
    }

    private void createConflictValueButton()
    {
        _conflictValueButton = new JButton("use conflict value");
        _conflictValueButton.setEnabled(false);
        add(_conflictValueButton);
    }

    private void createPreviewButton()
    {
        _previewButton = new JButton("preview");
        _previewButton.setEnabled(false);
        add(_previewButton);
    }

    private void createSaveButton()
    {
        _saveButton = new JButton("save");
        _saveButton.setEnabled(false);
        add(_saveButton);
    }

    public void enableButtons()
    {
        setButtonsEnabled(true);
    }

    public void disableButtons()
    {
        setButtonsEnabled(false);
    }

    private void setButtonsEnabled(boolean flag)
    {
        _currentValueButton.setEnabled(flag);
        _conflictValueButton.setEnabled(flag);
        _previewButton.setEnabled(flag);
        _saveButton.setEnabled(flag);
    }

    public JButton getCurrentValueButton()
    {
        return _currentValueButton;
    }

    public JButton getConflictValueButton()
    {
        return _conflictValueButton;
    }

    public JButton getPreviewButton()
    {
        return _previewButton;
    }

    public JButton getSaveButton()
    {
        return _saveButton;
    }
}
