
package de.codedo.conflicteditor.gui;

import java.awt.Component;

import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class ExceptionHandlingListSelectionListener extends Object implements ListSelectionListener
{
    private Executable<ListSelectionEvent> _executable;

    public ExceptionHandlingListSelectionListener(Executable<ListSelectionEvent> executable)
    {
        super();
        _executable = executable;
    }

    @Override
    public void valueChanged(ListSelectionEvent event)
    {
        try
        {
            _executable.execute(event);
        }
        catch (Exception ex)
        {
            String stacktrace = ExceptionUtil.toString(ex);
            Component source = (Component)event.getSource();
            JOptionPane.showMessageDialog(source, stacktrace, "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
}
